﻿unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons,PdfiumLib,PdfiumCore,PdfiumCtrl,PdfSharp;

type
  TForm1 = class(TForm)
    btn1: TBitBtn;
    dlgOpen1: TOpenDialog;
    edt1: TEdit;
    edt2: TEdit;
    BitBtn1: TBitBtn;
    btn2: TBitBtn;
    btn3: TBitBtn;
    procedure btn1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
  private
    { Private declarations }
    procedure MergePDFs(const InputFiles: array of string; const OutputFile: string);
    function LoadFontData(const FontFileName: string; out FontData: PByte; out FontSize: DWORD): Boolean;
    procedure AddPageNumbers(const InputFile, OutputFile, FontFile: string);
    procedure addpagenumber(const apdf:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
//procedure AddPageNumbersbySynpdf(PdfDoc: TSynPdfDocument);
//var
//  Page: TSynPdfPage;
//  Text: TSynPdfText;
//begin
//  for Page in PdfDoc.Pages do
//  begin
//    Text := Page.AddText;
//    Text.Font.Name := 'Arial';
//    Text.FontSize := 10;
//    Text.X := Page.Width - 50; // 頁面右邊緣減去 50 個單位
//    Text.Y := Page.Height - 20; // 頁面下邊緣減去 20 個單位
//    Text.Alignment := taRight;
//    Text.Text := IntToStr(Page.PageNumber);
//  end;
//end;

procedure TForm1.AddPageNumbers(const InputFile, OutputFile, FontFile: string);
var
  Document: FPDF_DOCUMENT;
  Page: FPDF_PAGE;
  TextObject: FPDF_PAGEOBJECT;
  PageCount, i: Integer;
  Text: PWideChar;
  Font: FPDF_FONT;
  FontData: PByte;
  FontSize: DWORD;
  Matrix: pFS_MATRIX;
begin
  // 初始化 PDFium
  FPDF_InitLibrary();

  try
    // 載入 PDF 檔案
    Document := FPDF_LoadDocument(PAnsiChar(InputFile), nil);
    if Document = nil then
      raise Exception.Create('Unable to load PDF file.');

    PageCount := FPDF_GetPageCount(Document);

    // 載入字型資料
    if not LoadFontData(FontFile, FontData, FontSize) then
      raise Exception.Create('Unable to load font data.');

    for i := 0 to PageCount - 1 do
    begin
      // 載入頁面
      Page := FPDF_LoadPage(Document, i);
      if Page = nil then
        raise Exception.Create('Unable to load page.');

      // 建立文字對象
      Font := FPDFText_LoadFont(Document, FontData, FontSize, 0, 0);
      if Font = nil then
      begin
        FPDF_ClosePage(Page);
        raise Exception.Create('Unable to load font.');
      end;

      TextObject := FPDFPageObj_CreateTextObj(Document, Font, 12);
      if TextObject = nil then
      begin
        FPDF_ClosePage(Page);
        raise Exception.Create('Unable to create text object.');
      end;

      // 設定頁碼文字
      // 設定文字對象位置
      Matrix.a := 1;     // 水平縮放
      Matrix.b := 0;     // 斜切
      Matrix.c := 0;     // 斜切
      Matrix.d := 1;     // 垂直縮放
      Matrix.e := 100;   // x位置
      Matrix.f := 700;   // y位置
      Text := PWideChar(Format('Page %d of %d', [i + 1, PageCount]));
      if FPDFText_SetText(TextObject, Text)<>1 then  begin
        FPDFPageObj_Destroy(TextObject);
        FPDF_ClosePage(Page);
        raise Exception.Create('Failed to set text for text object.');
      end;

      // 設定文字對象位置（示例坐標）
      FPDFPageObj_SetMatrix(TextObject,@Matrix); // 調整坐標

      // 將文字對象新增到頁面
      FPDFPage_InsertObject(Page, TextObject);

      // 釋放頁面
      FPDF_ClosePage(Page);
    end;

    // 保存到新檔案
//    if  FPDF_SaveAsCopy(Document, PChar(OutputFile))<>1 then
//      raise Exception.Create('Failed to save PDF.');

  finally
    // 釋放文件和字型資料
    FPDF_CloseDocument(Document);
    FPDF_DestroyLibrary();
    if Assigned(FontData) then
      FreeMem(FontData);
  end;
end;

function TForm1.LoadFontData(const FontFileName: string; out FontData: PByte; out FontSize: DWORD): Boolean;
var
  FileStream: TFileStream;
begin
  Result := False;
  FontData := nil;
  FontSize := 0;

  FileStream := TFileStream.Create(FontFileName, fmOpenRead);
  try
    FontSize := FileStream.Size;
    GetMem(FontData, FontSize);
    FileStream.Read(FontData^, FontSize);
    Result := True;
  finally
    FileStream.Free;
  end;
end;
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   try
    dlgOpen1:=TOpenDialog.Create(Application);
    dlgOpen1.Title := '選擇 PDF 檔案';
    dlgOpen1.Filter := 'PDF Files (*.pdf)|*.pdf';
    dlgOpen1.Options := dlgOpen1.Options + [ofFileMustExist];

    if dlgOpen1.Execute then
    begin
      // 這裡可以處理選擇的 PDF 檔案
      //ShowMessage('選擇的 PDF 檔案: ' + dlgOpen1.FileName);
      edt2.Text:=dlgOpen1.FileName;
    end;
  finally
    dlgOpen1.Free;
  end;

end;

procedure TForm1.btn1Click(Sender: TObject);
begin
   try
   dlgOpen1:=TOpenDialog.Create(Application);
    dlgOpen1.Title := '選擇 PDF 檔案';
    dlgOpen1.Filter := 'PDF Files (*.pdf)|*.pdf';
    dlgOpen1.Options := dlgOpen1.Options + [ofFileMustExist];

    if dlgOpen1.Execute then
    begin
      // 這裡可以處理選擇的 PDF 檔案
      //ShowMessage('選擇的 PDF 檔案: ' + dlgOpen1.FileName);
      edt1.Text:=dlgOpen1.FileName;
    end;
  finally
    dlgOpen1.Free;
  end;
end;


procedure TForm1.btn2Click(Sender: TObject);
begin
   MergePDFs([edt1.Text,edt2.Text],'g:\testpdf\mergepdf.pdf');
  // addpagenumber('g:\testpdf\mergepdf.pdf');  //win10以後可能會死當
end;

procedure TForm1.MergePDFs(const InputFiles: array of string; const OutputFile: string);
var
  MainDoc, TempDoc: TPdfDocument;
  pdfdoc:FPDF_DOCUMENT;
  i,pagecount: Integer;
begin
  MainDoc := TPdfDocument.Create;

  try
    // ... 其他初始化操作

    for i := Low(InputFiles) to High(InputFiles) do
    begin
      TempDoc := TPdfDocument.Create;
      try
        if not MainDoc.Active then begin
           MainDoc.NewDocument;
        end;

        TempDoc.LoadFromFile(InputFiles[i]);
        if not MainDoc.ImportAllPages(TempDoc) then
        begin
          // 處理導入頁面失敗的情況
          ShowMessage('Failed to import pages from ' + InputFiles[i]);
        end;

      finally
        TempDoc.Free;
      end;
    end;

    MainDoc.SaveToFile(OutputFile);
  finally
    MainDoc.Free;
  end;
end;

procedure TForm1.addpagenumber(const apdf:string);
var   DocumentA: _PdfDocument;
  Page: _PdfPage;
  FileName: string;
  Reader: _PdfReaderClass;
  Graphics: _XGraphics;
  Font: _XFont;
  Rect: XRect;
  Brush: _XBrush;
  i,x:Integer;
begin
   DocumentA := CoPdfDocument.Create;
   Reader := CoPdfReaderClass.Create;

   Font := CoXFontClass.Create.XFont('Arial', 10);
   Brush := CoXBrushesClass.Create.black.XBrush;

   DocumentA := Reader.Open( apdf, PdfDocumentOpenMode_Modify);

   for i := 1 to DocumentA.PageCount-1 do begin  //把文件加上頁碼 ,從1開始 ,第0頁是封面, 封面不用頁碼
           page:=Documenta.Pages[i];
           Rect._x := 0;
           Rect._y := 600;
           Rect._width := Page.Width._value;
           Rect._height := Page.Height._value / 2;

           Graphics := CoXGraphicsClass.Create.FromPdfPage(Page);   //會死當
           Graphics.DrawString_6(IntToStr(I), Font, Brush, Rect, CoXStringFormatsClass.Create.Center); //會死當

           DocumentA.Outlines.Add_5(IntToStr(I), Page);



   end;
    filename:='g:\testpdf\mergepdfAddnumber.pdf';

   DocumentA.Save(FileName);
end;

end.
